unit DrBobCED;
interface
uses
  DsgnIntf, DBTables, DBWeb;

type
  TQueryTableProducerComponentEditor = class(TComponentEditor)
  public
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): String; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

  procedure Register;

implementation
uses
  DrBobWiz, Classes, Controls, Forms;

  function TQueryTableProducerComponentEditor.GetVerbCount: Integer;
  begin
    Result := 1
  end {GetVerbCount};

  function TQueryTableProducerComponentEditor.GetVerb(Index: Integer): String;
  begin
    Result := 'Query-2-HTML CGI-Form Wizard...'
  end {GetVerb};

  procedure TQueryTableProducerComponentEditor.ExecuteVerb(Index: Integer);
  begin
    with TFormWizard.Create(Application) do
    try
      with (Component AS TQueryTableProducer) do
      begin
        if Assigned(Query) then
        begin
          ComboBoxAliases.Text := (Query AS TQuery).DatabaseName;
          MemoSQL.Lines.Assign((Query AS TQuery).SQL);
          if Assigned((Query AS TQuery).Params) then
            TheQuery.Params.Assign((Query AS TQuery).Params)
        end
      end;
      if ShowModal = mrOK then Finish
    finally
      Free
    end
  end {Edit};

  procedure Register;
  begin
    RegisterComponentEditor(TQueryTableProducer, TQueryTableProducerComponentEditor)
  end;
end.
