unit QueryBob;
interface
uses
  VirtIntf, ExptIntf, ToolIntf, Windows, SysUtils, Menus, Classes, Controls,
  Forms, DrBobWiz;

{ EXPERT TYPE DEFINITION }

Type
  TBAddInWizard = class(TIExpert)
  public
  { Expert Style }
    function GetStyle: TExpertStyle; override;

  { Expert Strings }
    function GetIDString: string; override;
    function GetName: string; override;
    function GetAuthor: String; override;

  { Launch the Expert }
    procedure Execute; override;

  { AddIn Expert }
    constructor Create; virtual;
    destructor Destroy; override;
  protected
    procedure OnClick(Sender: TIMenuItemIntf); virtual;
  private
    NewMenuItem: TIMenuItemIntf;
  end {TBAddInWizard};

  procedure Register;

implementation

{ EXPERT IMPLEMENTATION }

function TBAddInWizard.GetStyle: TExpertStyle;
begin
  Result := esAddIn
end {GetStyle};

function TBAddInWizard.GetIDString: String;
begin
  Result := 'TBAddInWizard.esAddIn'
end {GetIDString};

function TBAddInWizard.GetName: String;
begin
  Result := 'DrBob''s TBAddInWizard'
end {GetName};

function TBAddInWizard.GetAuthor: String;
begin
  Result := 'Bob Swart (aka Dr.Bob)'
end {GetAuthor};

constructor TBAddInWizard.Create;
var
  MainMenu: TIMainMenuIntf;
  MainItem: TIMenuItemIntf;
  MenuItem: TIMenuItemIntf;
begin
  inherited Create;
  NewMenuItem := nil;
  if ToolServices <> nil then
  begin
    MainMenu := ToolServices.GetMainMenu;
    if MainMenu <> nil then { main menu }
    try
      MenuItem := MainMenu.FindMenuItem('Borland_FormExpertMenu');
      if MenuItem <> nil then
      try
        MainItem := MenuItem.GetParent;
        if MainItem <> nil then
        try
          NewMenuItem :=
            MainItem.InsertItem(MenuItem.GetIndex+1,
                               '&Dr.Bob''s QueryBob Wizard...',
                               'BAddInWizard1','',
                                ShortCut(Ord('D'),[ssShift,ssAlt,ssCtrl]),0,0,
                               [mfEnabled, mfVisible], OnClick)
        finally
          MainItem.DestroyMenuItem
        end
      finally
        MenuItem.DestroyMenuItem
      end
    finally
      MainMenu.Free
    end
  end
end {Create};

destructor TBAddInWizard.Destroy;
begin
  if NewMenuItem <> nil then
    NewMenuItem.DestroyMenuItem;
  inherited Destroy
end {Destroy};

procedure TBAddInWizard.OnClick(Sender: TIMenuItemIntf);
begin
  Execute
end {OnClick};

{ EXPERT EXECUTE }

procedure TBAddInWizard.Execute;
begin
  with TFormWizard.Create(Application) do
  try
    if ShowModal = mrOK then Finish
  finally
    Free
  end
end {Execute};

{ DCU EXPERT INTERFACE }

  procedure Register;
  begin
    RegisterLibraryExpert(TBAddInWizard.Create);
  end {Register};
end.
